/*
	Genome-wide Efficient Mixed Model Association (GEMMA)
    Copyright (C) 2011  Xiang Zhou and Matthew Stephens

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <fstream>
#include <sys/stat.h>
#include <sys/types.h>
#include "gsl/gsl_vector.h"
#include "gsl/gsl_matrix.h"

#include "param.h"
#include "gemma.h"


using namespace std;



int main(int argc, char * argv[])
{ 	
	PARAM cPar;	

	if (argc <= 1) {
		cPar.PrintHeader(); 
		return 1;
	}
	if (argc==2 && argv[1][0] == '-' && argv[1][1] == 'h') {
		cPar.PrintHelp();
		return 1;
	}
	if (argc==2 && argv[1][0] == '-' && argv[1][1] == 'l') {
		cPar.PrintLicense();
		return 1;
	}
	
	ifstream check_dir("output/");
	if (!check_dir) {
		mkdir("output", S_IRWXU);
	}
	
	
	GEMMA cGemma;	
	
	cPar.Assign(argc, argv, cGemma); 			
	
	if (cGemma.error==true) {return 1;}
	if (cPar.CheckError(cGemma)==true) {return 1;}
	
	cPar.BatchRun(cGemma);
		
    return EXIT_SUCCESS;                                                          
}


 
